/*
Lowport routine for the internal BUS
*/

#include "lowport.h"

#include <avr/io.h>

//extern void bigbin2bcd(char *dest, char *binaryvalue, unsigned char destsize, 
//                       unsigned char binarysize);

static unsigned char ucTokenPosition;
static unsigned char cMaxBusSize = ucTimeDigits + ucTempDigits;
static unsigned char cMaxTokenSize = 16; //cMaxBusSize*2;

static unsigned char ucToBCD [10] = 
        {0x3F, //0011 1111,  //0
         0x06, //0000 0110, //1
         0x5B, //0101 1011, //2
         0x4F, //0100 1111, //3
         0x66, //0110 0110, //4
         0x6D, //0110 1101, //5
         0x7D, //0111 1101, //6
         0x03, //0000 0111, //7
         0x7F, //0111 1111, //8
         0x6F};//0110 1111};//9

static unsigned char TokenInLoop (void)
  {
    if (ucTokenPosition != 0)
      return 1;
    return 0;
  }

static void ClockForward (void)
  {
    unsigned int i;
    set_bit (PORTB, CLOCK);
    for (i = 0; i < 100; i++){};
    clear_bit (PORTB, CLOCK);
  }

static void SetToken (void)
  {
    set_bit (PORTB, TOKEN);
    ClockForward ();
    clear_bit (PORTB, TOKEN);
    ucTokenPosition++;
  }

static void ResetToken (void)
  {
    clear_bit (PORTB, TOKEN);
  }

static void EnableLatch (void)
  {
    unsigned int i;
    set_bit (PORTB, DATA3);
    for (i = 0; i < 100; i++){};
    clear_bit (PORTB, DATA3);
  }

static void SetBit (
    unsigned char ucPosition,
    unsigned char ucBitValue
  )
  {
    unsigned char i;
//    clear_bit (PORTB, DATA3);

    if ((ucPosition & 0x01) == 0x01)
      set_bit (PORTB, DATA0);
    else
      clear_bit (PORTB, DATA0);
    if ((ucPosition & 0x02) == 0x02)
      set_bit (PORTB, DATA1);
    else
      clear_bit (PORTB, DATA1);

    if ((ucBitValue & 0x01) == 0x01)
      set_bit (PORTB, DATA2);

//    for (i = 0; i < 100; i++){};
/*    set_bit (PORTB, DATA3);
    clear_bit (PORTB, DATA3);*/
    
//    EnableLatch ();
/*    for (i = 0; i < 100; i++){};
    clear_bit (PORTB, DATA0);
    clear_bit (PORTB, DATA1);
    clear_bit (PORTB, DATA2);*/
  }

static void SetTokenForward (void)
  {
    if (TokenInLoop ())
      {
        ClockForward ();
        ucTokenPosition++;
      }
    else
      SetToken ();
  }

static void SetByte (
    unsigned char ucByte
  )
  {
    unsigned char i;
    for (i = 0; i < 8; i++)
      {
        if (i == 0x04)
          SetTokenForward ();
        SetBit (i, 0x01);//ucByte >> i);
      }
    SetTokenForward ();
  }


static void HexToAscii (
    unsigned int   uiVal,
    unsigned char* pDest
  )
  {
    pDest [0] = ((uiVal % 1000)%100)%10;
    pDest [1] = ((uiVal % 1000)%100)/10;
    pDest [2] = (uiVal % 1000)/100;
    pDest [3] = uiVal / 1000;
  }

//Exported functions 
void LowPortInit (void)
  {
    unsigned char i;
    ucTokenPosition = 0;
    ucUpdateDisplay = 0;
    
    for (i = 0; i < cMaxBusSize; i++)
      ucDisplayValue [i] = 0xff ^ 0x3F;
    ucUpdateDisplay++;
    LowPortUpdateDisplay ();
    ucUpdateDisplay = 0;
  }

void LowPortUpdateDisplay (void)
  {
    unsigned char i = 0;
    clear_bit (PORTB, DATA3);
    if (ucUpdateDisplay > 0)
      {
        ucTokenPosition = 0;
        ucUpdateDisplay--;
        SetToken ();
        do
          {
    set_bit (PORTB, DATA3);
            SetByte (ucDisplayValue [i]);//(ucTokenPosition - 1) / 2]);
    clear_bit (PORTB, DATA3);
            i++;
          }
        while (ucTokenPosition <= cMaxTokenSize);
      }
    else
      return;
  }

void LowPortClearAll (void)
  {
    ResetToken ();
    
    ucTokenPosition = 0;
    LowPortInit ();
  }

void LowPortSetByte (
    unsigned char ucByteNo,
    unsigned int  uiVal
  )
  {
    unsigned char i;
    unsigned char ucDest [4];
    HexToAscii (uiVal, ucDest);

    for (i = 0; i < 4; i++)    
      {
        ucDisplayValue [i+ ((ucByteNo-1)*4)] = ucDest[i];
        ucDisplayValue [i+ ((ucByteNo-1)*4)] = 0xFF ^ ucToBCD [ucDest[i]];
      }
    ucUpdateDisplay++;
  }

void LowPortClearUpperLight (void)
  {
  }

void LowPortClearDownLight  (void)
  {
  }


  