/*
Declaration for lowport.c
*/

#ifndef _LOWPORT_H
#define _LOWPORT_H

#include <avr/io.h>
#include <stdio.h>

//Portdefinition
#define TOKEN PB0
#define CLOCK PB1

#define DATA0 PB2
#define DATA1 PB3
#define DATA2 PB4
#define DATA3 PB5

//Global variables
#define ucTimeDigits 4
#define ucTempDigits 4

//const unsigned char ucTimeDigits   = 4;
//const unsigned char ucTempDigits   = 4;

//const unsigned char ucMaxBusSize   = 8; //ucTimeDigits + ucTempDigits;
//const unsigned char ucMaxTokenSize = 16; //ucMaxBusSize*2;


//Makros
#define set_bit(sfr,bit) (_SFR_BYTE(sfr) |= _BV(bit))
#define clear_bit(sfr,bit) (_SFR_BYTE(sfr) &= ~(_BV(bit)))

volatile unsigned char ucDisplayValue [ucTimeDigits + ucTempDigits];
volatile unsigned char ucUpdateDisplay;

//Exported functions
void LowPortInit (void);

void LowPortUpdateDisplay (void);

void LowPortClearAll (void);
  
void LowPortSetByte (
    unsigned char ucByteNo,
    unsigned int  uiVal
  );
  
  
void LowPortClearUpperLight (void);

void LowPortClearDownLight  (void);
  
#endif
